<?php

/* setup includes */
require_once('includes/master.inc.php');

/* require login */
$Auth->requireUser('login.php');

// setup initial params
$s = (int)$_REQUEST['iDisplayStart'];
$l = (int)$_REQUEST['iDisplayLength'];
$sortCol = (int)$_REQUEST['iSortCol_0'];
$sortDir = $_REQUEST['sSortDir_0']=='asc'?'asc':'desc';
$sSearch = trim($_REQUEST['filterText']);
$filterByStatus = isset($_REQUEST['filterByStatus'])?$_REQUEST['filterByStatus']:'';
$filterByFolder = isset($_REQUEST['filterByFolder'])?(int)$_REQUEST['filterByFolder']:null;

$db = Database::getDatabase(true);
$clause = "WHERE userId = " . (int)$Auth->id;
if(strlen($sSearch))
{
    $clause .= " AND (originalUrl LIKE '%".$db->escape($sSearch)."%' OR shortUrl LIKE '%".$db->escape($sSearch)."%')";
}

if(strlen($filterByStatus) > 0)
{
    $clause .= " AND status = ".$db->quote($filterByStatus)." ";
}

if($filterByFolder)
{
    $clause .= " AND shortUrlFolder = ".(int)$filterByFolder." ";
}

$sortColName = 'originalUrl';
switch($sortCol)
{
    case 1:
        $sortColName = 'originalUrl';
        break;
    case 2:
        $sortColName = 'dateCreated';
        break;
    case 3:
        $sortColName = 'visits';
        break;
}

// get file total for this account and filter
$allUrls = $db->getValue('SELECT COUNT(id) AS total FROM shorturl '.$clause);

// load limited page filtered
$urls = $db->getRows('SELECT * FROM shorturl '.$clause.' ORDER BY '.$sortColName.' '.$sortDir.' LIMIT '.$s.','.$l);

$data = array();
if ($urls)
{
    foreach ($urls AS $url)
    {
        $lrs = array();

        if ($url['status'] == 'active')
        {
            $lrs[] = '<img src="shortUrlIcon.php?id=' . $url['id'] . '" width="16" height="16"/>';
        }
        else
        {
            $lrs[] = '';
        }

        $link = '';
        if ($url['status'] == 'active')
        {
            $link .= '<a href="' . shortUrl::getShortUrlDomain($url['urlDomainId']) . '/' . $url['shortUrl'] . '" target="_blank">';
        }
        $urlName = '<span class="mobileHide">'.shortUrl::getShortUrlDomain($url['urlDomainId']) . '</span>/' . $url['shortUrl'];
        $urlName = wordwrap($urlName, 100, "<br/>", true);
        $link .= $urlName;
        if ($url['status'] == 'active')
        {
            $link .= '</a>';
        }
        
        $link .= '<br/><span class="resultingSite mobileHide">' . shortUrl::formatLongUrlForScreen($url['originalUrl']) . '</span>';
        $lrs[] = $link;

        $lrs[] = dater($url['dateCreated']) . '<br/>' . dater($url['lastAccessed']);
        $lrs[] = $url['visits'];
        $lrs[] = t($url['status'], $url['status']);

        $links = array();
        $links[] = '<a href="http://' . _CONFIG_SITE_FULL_URL . '/' . $url['shortUrl'] . '~s"><img src="' . SITE_IMAGE_PATH . '/chart_pie.png" width="16" height="16" title="'.t('short_url_stats', 'short url stats').'" style="margin-right: 1px;"/></a>';
        if ($url['status'] == 'active')
        {
            $links[] = '<a href="index.html?u=' . $url['id'] . '&success=1"><img src="' . SITE_IMAGE_PATH . '/group.png" width="16" height="16" title="'.t('share', 'share').'" style="margin-left: 1px; margin-right: 1px;"/></a>';
        }
        if($url['status'] != 'spam')
        {
            $links[] = '<a href="http://' . _CONFIG_SITE_FULL_URL . '/account_url_edit.' . SITE_CONFIG_PAGE_EXTENSION . '?id=' . $url['id'] . '"><img src="' . SITE_IMAGE_PATH . '/link_edit.png" width="16" height="16" title="'.t('edit_shorl_url', 'edit shorl url').'" style="margin-left: 1px; margin-right: 1px;"/></a>';
        }
        if ($url['status'] == 'active')
        {
            $links[] = '<a href="http://' . _CONFIG_SITE_FULL_URL . '/account_home.' . SITE_CONFIG_PAGE_EXTENSION . '?d=' . $url['id'] . '" onClick="return confirm(\''.t('are_you_sure_you_want_to_delete_this_url', 'Are you sure you want to permanently delete this short url?').'\');"><img src="' . SITE_IMAGE_PATH . '/delete.png" width="16" height="16" title="'.t('delete_shorl_url', 'delete shorl url').'" style="margin-left: 1px"/></a>';
        }
        $lrs[]   = implode("&nbsp;", $links);

        $data[] = $lrs;
    }
}

// create json response
$result = array();
$result['sEcho']                = intval($_GET['sEcho']);
$result['iTotalRecords']        = $allUrls;
$result['iTotalDisplayRecords'] = $allUrls;
$result['aaData']               = $data;

echo json_encode($result);