<?php
/* setup page */
define("PAGE_NAME", t("captcha_page_name", "Captcha Confirmation Required"));
define("PAGE_DESCRIPTION", t("captcha_meta_description", "Captcha confirmation required"));
define("PAGE_KEYWORDS", t("captcha_meta_keywords", "captcha,confirmation,required"));
require_once('_header.php');
?>

<div class="span9">
    <?php
    if (isErrors())
    {
        echo outputErrors();
    }
    ?>
    <!-- captcha output -->
    <form method="POST" action="index.<?php echo SITE_CONFIG_PAGE_EXTENSION; ?>" autocomplete="off" class="form">
        <div>
            <h5>
                <?php echo t("captcha_confirmation", "Captcha Confirmation"); ?>
            </h5>
            <p>
                <?php echo t("in_order_to_prevent_abuse_captcha_intro_below", "In order to prevent abuse of this service, please copy the words into the text box below."); ?>
            </p>

            <div>
                <?php
                echo recaptcha_get_html(SITE_CONFIG_CAPTCHA_PUBLIC_KEY);
                ?>
                <div class="clear"><!-- --></div>
            </div>

            <div class="buttonWrapper" style="padding-top: 18px;">
                <button type="submit" name="submit" class="btn btn-primary" tabindex="99"><?php echo t("continue", "continue"); ?></button>
            </div>
            <div class="clear"></div>

            <div>
                <input type="hidden" name="longUrl" value="<?php echo safeOutputToScreen($longUrl); ?>"/>
                <input type="hidden" name="agreeTerms" value="<?php echo safeOutputToScreen($agreeTerms); ?>"/>
                <input type="hidden" name="shortUrlType" value="<?php echo safeOutputToScreen($isPrivate); ?>"/>
                <input type="hidden" name="shortUrlPassword" value="<?php echo safeOutputToScreen($password); ?>"/>
                <input type="hidden" name="shortUrlExpiryDate" value="<?php echo safeOutputToScreen($expiryDate); ?>"/>
                <input type="hidden" name="shortUrlUses" value="<?php echo safeOutputToScreen($totalUses); ?>"/>
                <input type="hidden" name="customUrl" value="<?php echo safeOutputToScreen($customUrl); ?>"/>
                <input type="hidden" name="shortUrlDomain" value="<?php echo safeOutputToScreen($shortUrlDomain); ?>"/>
                <input type="hidden" name="shortUrlFolder" value="<?php echo safeOutputToScreen($shortUrlFolder?$shortUrlFolder:''); ?>"/>
                <input type="hidden" name="submitted" value="1"/>
            </div>
            <div class="clear"><!-- --></div>
        </div>
        <div class="clear"><!-- --></div>
    </form>
</div>

<div class="span3 page_sidebar">
    <div class="well">
        <h4>
            <?php echo t('malware_protection', 'Malware Protection'); ?>
        </h4>
        <hr/>
        <p>
            <?php echo t('we_use_the_most_up_to_date_sources_malware_phishing', 'We use the most up to date sources available on the internet to block links being created for sites which may contain viruses, spam or malware.'); ?>
        </p>
        <ul>
            <li><a href="http://www.phishtank.com/" target="_blank">PhishTank</a></li>
            <li><a href="https://developers.google.com/safe-browsing/" target="_blank">Google Safe Browsing</a></li>
        </ul>
    </div>
</div>

<?php
require_once('_footer.php');
?>