<?php
/* setup includes */
require_once('includes/master.inc.php');

if (SITE_CONFIG_ENABLE_STATS != "yes")
{
    /* if no stats, redirect to homepage */
    redirect(WEB_ROOT . "/index." . SITE_CONFIG_PAGE_EXTENSION);
}

/* fusion charts php class */
require_once('js/fusionCharts/Code/PHPClass/Includes/FusionCharts.php');

/* setup page */
define("PAGE_NAME", t("stats_page_name"));
define("PAGE_DESCRIPTION", t("stats_meta_description"));
define("PAGE_KEYWORDS", t("stats_meta_keywords"));

/* load url details */
if ($_REQUEST['url'])
{
    $shortUrlObj = shortUrl::loadByUrl(str_replace(array("!", "~s"), "", $_REQUEST['url']));
}
else
{
    /* if no short url found, redirect to home page */
    redirect(WEB_ROOT . "/index." . SITE_CONFIG_PAGE_EXTENSION);
}

require_once('_header.php');

/* setup colours */
$colours   = explode("|", "B02B2C|D15600|C79810|73880A|6BBA70|3F4C6B|356AA0|D01F3C");
?>

<script>
    $=jQuery;
    $(document).ready(function($) {
        showChart('visitorChart2');
    });
    function showChart(chartId)
    {
        $('.chart').hide();
        $('.link_selected').removeClass('link_selected');
        $('#'+chartId).fadeIn();
        $('#link_'+chartId).addClass('link_selected');
        
        return false;
    }
</script>

<div class="span12 statsWrapper">
    <div class="blog_item">
        <div class="blog_head">
            <div class="date">
                <h6><i class="icon-signal icon-white"></i> <?php echo $shortUrlObj->visits; ?> <?php echo $shortUrlObj->visits == 1 ? t("visit", "visit") : t("visits", "visits"); ?></h6>
            </div>
            <h3><a href="<?php echo $shortUrlObj->compileShortUrl(); ?>" target="_blank"><?php echo str_replace("http://", "", $shortUrlObj->compileShortUrl()); ?></a></h3>
            <div class="meta">
                <span class="last-item"><b><?php echo t("created_"); ?></b> <?php echo dater($shortUrlObj->dateCreated); ?></span>
            </div>
        </div>
    </div>
</div>
<div class="clear" style="padding-top: 12px;"></div>

<div class="span3 page_sidebar">
    <div class="well">
        <h5><?php echo t('select_report', 'select report'); ?></h5>
        <hr>
        <div class="textwidget">
            <ul class="sub-menu">
                <li><a href="#" onClick="return showChart('visitorChart1');"><?php echo t("visitors"); ?></a>
                    <ul>
                        <li><a href="#" id="link_visitorChart1" onClick="return showChart('visitorChart1');"><?php echo t("last_24_hours"); ?></a></li>
                        <li><a href="#" id="link_visitorChart2" onClick="return showChart('visitorChart2');"><?php echo t("last_7_days"); ?></a></li>
                        <li><a href="#" id="link_visitorChart3" onClick="return showChart('visitorChart3');"><?php echo t("last_30_days"); ?></a></li>
                        <li><a href="#" id="link_visitorChart4" onClick="return showChart('visitorChart4');"><?php echo t("last_12_months"); ?></a></li>
                    </ul>
                </li>
                <li><a href="#" id="link_countryChart" onClick="return showChart('countryChart');"><?php echo t("countries"); ?></a></li>
                <li><a href="#" id="link_referChart" onClick="return showChart('referChart');"><?php echo t("top_referrers"); ?></a></li>
                <li><a href="#" id="link_browserChart" onClick="return showChart('browserChart');"><?php echo t("browsers"); ?></a></li>
                <li><a href="#" id="link_osChart" onClick="return showChart('osChart');"><?php echo t("operating_systems"); ?></a></li>
            </ul>
        </div>
    </div>
</div>

<div class="span9 statsWrapper">
    <div class="blog_item">
        <div class="row">
            <div class="span9">
                <div id="visitorChart1" style="display:none;" class="chart">
                    <div class="chartItem">
                    <?php
                    /* last 24 hours chart */
                    $tracker   = 24;
                    $last7Days = array();
                    while ($tracker >= 0)
                    {
                        $date             = date("Y-m-d H:i:s", strtotime("-" . $tracker . " hour"));
                        $last7Days[$date] = 0;
                        $tracker--;
                    }

                    $db = Database::getDatabase(true);

                    $minY = 0;
                    $maxY = 10;
                    foreach ($last7Days AS $k => $total)
                    {
                        $totalUrls     = $db->getValue("SELECT COUNT(id) AS total FROM stats WHERE MID(dt, 1, 13) = '" . substr($k, 0, 13) . "' AND page_title = '" . $shortUrlObj->id . "'");
                        $last7Days[$k] = (int) $totalUrls;
                        if ($totalUrls > $maxY)
                        {
                            $maxY = $totalUrls;
                        }
                    }

                    $strXML = "";
                    $strXML .= "<graph yAxisMinValue='" . $minY . "' yAxisMaxValue='" . $maxY . "' showColumnShadow='0' canvasBorderThickness='1' showValues='0' canvasBgColor='dddddd' divlinecolor='ffffff' canvasBorderColor='cccccc' rotateNames='0' animation='1' xAxisName='" . UCWords(t("time", "time")) . "' yAxisName='" . t("visits") . "' decimalPrecision='0' formatNumberScale='0' baseFont='Arial' baseFontSize='12'>";
                    foreach ($last7Days AS $k => $total)
                    {
                        $position = rand(0, COUNT($colours) - 1);
                        $strXML .= "<set name='" . dater($k, "H") . "' value='" . (string) $total . "' color='" . $colours[$position] . "'/>";
                    }
                    $strXML .= "</graph>";

                    echo renderChartHTML("js/fusionCharts/Charts/FCF_Column2D.swf?noCache=" . microtime(true), "", $strXML, "hourChart", 890, 350);
                    ?>

                    <?php
                    /* total visits figure */
                    $totalVisits = 0;
                    foreach ($last7Days AS $k => $total)
                    {
                        $totalVisits = $totalVisits + $total;
                    }
                    ?>
                    </div>

                    <br/>

                    <div>
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th class="center"><?php echo UCWords(t("time", "time")); ?></th>
                                    <th class="center"><?php echo UCWords(t("total_visits")); ?></th>
                                    <th class="center"><?php echo UCWords(t("percentage")); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $last7Days   = array_reverse($last7Days, true);
                                foreach ($last7Days AS $k => $total)
                                {
                                    echo "<tr>";
                                    echo "<td class=\"center\">" . dater($k, "H:00") . "</td>";
                                    echo "<td class=\"center\">" . $total . "</td>";
                                    echo "<td class=\"center\">" . number_format(($total / $totalVisits) * 100, 1) . "%</td>";
                                    echo "</tr>";
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>
                </div>

                <div id="visitorChart2" style="display:none;" class="chart">
                    <div class="chartItem" style="width:300px;">
                    <?php
                    /* last 7 days chart */
                    $tracker   = 7;
                    $last7Days = array();
                    while ($tracker >= 0)
                    {
                        $date             = date("Y-m-d", strtotime("-" . $tracker . " day"));
                        $last7Days[$date] = 0;
                        $tracker--;
                    }

                    $db = Database::getDatabase(true);

                    $minY = 0;
                    $maxY = 10;
                    foreach ($last7Days AS $k => $total)
                    {
                        $totalUrls     = $db->getValue("SELECT COUNT(id) AS total FROM stats WHERE MID(dt, 1, 10) = '" . $k . "' AND page_title = '" . $shortUrlObj->id . "'");
                        $last7Days[$k] = (int) $totalUrls;
                        if ($totalUrls > $maxY)
                        {
                            $maxY = $totalUrls;
                        }
                    }

                    $strXML = "";
                    $strXML .= "<graph yAxisMinValue='" . $minY . "' yAxisMaxValue='" . $maxY . "' showColumnShadow='0' canvasBorderThickness='1' showValues='0' canvasBgColor='dddddd' divlinecolor='ffffff' canvasBorderColor='cccccc' rotateNames='0' animation='1' xAxisName='" . t("day") . "' yAxisName='" . t("visits") . "' decimalPrecision='0' formatNumberScale='0' baseFont='Arial' baseFontSize='12'>";
                    foreach ($last7Days AS $k => $total)
                    {
                        $position = rand(0, COUNT($colours) - 1);
                        $strXML .= "<set name='" . dater($k, "jS") . "' value='" . $total . "' color='" . $colours[$position] . "'/>";
                    }
                    $strXML .= "</graph>";

                    echo renderChartHTML("js/fusionCharts/Charts/FCF_Column2D.swf?noCache=" . microtime(true), "", $strXML, "weekChart", 890, 350);
                    ?>

                    <?php
                    /* total visits figure */
                    $totalVisits = 0;
                    foreach ($last7Days AS $k => $total)
                    {
                        $totalVisits = $totalVisits + $total;
                    }
                    ?>
                    </div>

                    <br/>

                    <div>
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th class="center"><?php echo UCWords(t("date")); ?></th>
                                    <th class="center"><?php echo UCWords(t("total_visits")); ?></th>
                                    <th class="center"><?php echo UCWords(t("percentage")); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $last7Days   = array_reverse($last7Days, true);
                                foreach ($last7Days AS $k => $total)
                                {
                                    echo "<tr>";
                                    echo "<td class=\"center\">" . dater($k, SITE_CONFIG_DATE_FORMAT) . "</td>";
                                    echo "<td class=\"center\">" . $total . "</td>";
                                    echo "<td class=\"center\">" . number_format(($total / $totalVisits) * 100, 1) . "%</td>";
                                    echo "</tr>";
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>
                </div>

                <div id="visitorChart3" style="display:none;" class="chart">
                    <div class="chartItem">
                    <?php
                    /* last 30 days chart */
                    $tracker   = 30;
                    $last7Days = array();
                    while ($tracker >= 0)
                    {
                        $date             = date("Y-m-d", strtotime("-" . $tracker . " day"));
                        $last7Days[$date] = 0;
                        $tracker--;
                    }

                    $db = Database::getDatabase(true);

                    $minY = 0;
                    $maxY = 10;
                    foreach ($last7Days AS $k => $total)
                    {
                        $totalUrls     = $db->getValue("SELECT COUNT(id) AS total FROM stats WHERE MID(dt, 1, 10) = '" . $k . "' AND page_title = '" . $shortUrlObj->id . "'");
                        $last7Days[$k] = (int) $totalUrls;
                        if ($totalUrls > $maxY)
                        {
                            $maxY = $totalUrls;
                        }
                    }

                    $strXML = "";
                    $strXML .= "<graph yAxisMinValue='" . $minY . "' yAxisMaxValue='" . $maxY . "' showColumnShadow='0' canvasBorderThickness='1' showValues='0' canvasBgColor='dddddd' divlinecolor='ffffff' canvasBorderColor='cccccc' rotateNames='0' animation='1' xAxisName='" . t("day") . "' yAxisName='" . t("visits") . "' decimalPrecision='0' formatNumberScale='0' baseFont='Arial' baseFontSize='12'>";
                    foreach ($last7Days AS $k => $total)
                    {
                        $position = rand(0, COUNT($colours) - 1);
                        $strXML .= "<set name='" . dater($k, "j") . "' value='" . $total . "' color='" . $colours[$position] . "'/>";
                    }
                    $strXML .= "</graph>";

                    echo renderChartHTML("js/fusionCharts/Charts/FCF_Column2D.swf?noCache=" . microtime(true), "", $strXML, "monthChart", 890, 350);
                    ?>

                    <?php
                    /* total visits figure */
                    $totalVisits = 0;
                    foreach ($last7Days AS $k => $total)
                    {
                        $totalVisits = $totalVisits + $total;
                    }
                    ?>
                    </div>

                    <br/>

                    <div>
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th class="center"><?php echo UCWords(t("date")); ?></th>
                                    <th class="center"><?php echo UCWords(t("total_visits")); ?></th>
                                    <th class="center"><?php echo UCWords(t("percentage")); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $last7Days   = array_reverse($last7Days, true);
                                foreach ($last7Days AS $k => $total)
                                {
                                    echo "<tr>";
                                    echo "<td class=\"center\">" . dater($k, SITE_CONFIG_DATE_FORMAT) . "</td>";
                                    echo "<td class=\"center\">" . $total . "</td>";
                                    echo "<td class=\"center\">" . number_format(($total / $totalVisits) * 100, 1) . "%</td>";
                                    echo "</tr>";
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>
                </div>

                <div id="visitorChart4" style="display:none;" class="chart">
                    <div class="chartItem">
                    <?php
                    /* last 12 months chart */
                    $tracker   = 12;
                    $last7Days = array();
                    while ($tracker >= 0)
                    {
                        $date             = date("Y-m", strtotime("-" . $tracker . " month"));
                        $last7Days[$date] = 0;
                        $tracker--;
                    }

                    $db = Database::getDatabase(true);

                    $minY = 0;
                    $maxY = 10;
                    foreach ($last7Days AS $k => $total)
                    {
                        $totalUrls     = $db->getValue("SELECT COUNT(id) AS total FROM stats WHERE MID(dt, 1, 7) = '" . $k . "' AND page_title = '" . $shortUrlObj->id . "'");
                        $last7Days[$k] = (int) $totalUrls;
                        if ($totalUrls > $maxY)
                        {
                            $maxY = $totalUrls;
                        }
                    }

                    $strXML = "";
                    $strXML .= "<graph yAxisMinValue='" . $minY . "' yAxisMaxValue='" . $maxY . "' showColumnShadow='0' canvasBorderThickness='1' showValues='0' canvasBgColor='dddddd' divlinecolor='ffffff' canvasBorderColor='cccccc' rotateNames='0' animation='1' xAxisName='" . t("month") . "' yAxisName='" . t("visits") . "' decimalPrecision='0' formatNumberScale='0' baseFont='Arial' baseFontSize='12'>";
                    foreach ($last7Days AS $k => $total)
                    {
                        $position = rand(0, COUNT($colours) - 1);
                        $strXML .= "<set name='" . dater($k, "M y") . "' value='" . $total . "' color='" . $colours[$position] . "'/>";
                    }
                    $strXML .= "</graph>";

                    echo renderChartHTML("js/fusionCharts/Charts/FCF_Column2D.swf?noCache=" . microtime(true), "", $strXML, "yearChart", 890, 350);
                    ?>

                    <?php
                    /* total visits figure */
                    $totalVisits = 0;
                    foreach ($last7Days AS $k => $total)
                    {
                        $totalVisits = $totalVisits + $total;
                    }
                    ?>
                    </div>

                    <br/>

                    <div>
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th class="center"><?php echo UCWords(t("date")); ?></th>
                                    <th class="center"><?php echo UCWords(t("total_visits")); ?></th>
                                    <th class="center"><?php echo UCWords(t("percentage")); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                $last7Days   = array_reverse($last7Days, true);
                                foreach ($last7Days AS $k => $total)
                                {
                                    echo "<tr>";
                                    echo "<td class=\"center\">" . dater($k, "M y") . "</td>";
                                    echo "<td class=\"center\">" . $total . "</td>";
                                    echo "<td class=\"center\">" . number_format(($total / $totalVisits) * 100, 1) . "%</td>";
                                    echo "</tr>";
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>
                </div>

                <div id="countryChart" class="chart">
                    <div class="chartItem">
                    <?php
                    /* pie chart */
                    $dataForPie = $db->getRows("SELECT country, COUNT(id) AS total FROM stats WHERE page_title = '" . $shortUrlObj->id . "' GROUP BY country ORDER BY total DESC");

                    $strXML = "";
                    $strXML .= "<graph animation='1' showValues='0' showNames='1' pieRadius='95' decimalPrecision='0' formatNumberScale='0' baseFont='Arial' baseFontSize='10'>";
                    foreach ($dataForPie AS $dataRow)
                    {
                        $position = rand(0, COUNT($colours) - 1);
                        $strXML .= "<set name='" . UCWords(t($dataRow['country'], $dataRow['country'])) . "' value='" . $dataRow['total'] . "' color='" . $colours[$position] . "'/>";
                    }
                    $strXML .= "</graph>";

                    echo renderChartHTML("js/fusionCharts/Charts/FCF_Pie2D.swf", "", $strXML, "statusPie", 830, 250);
                    ?>

                    <?php
                    /* total visits figure */
                    $totalVisits = 0;
                    foreach ($dataForPie AS $dataRow)
                    {
                        $totalVisits = $totalVisits + $dataRow['total'];
                    }
                    ?>
                    </div>

                    <br/>

                    <div>
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th><?php echo UCWords(t("country")); ?></th>
                                    <th class="center"><?php echo UCWords(t("total_visits")); ?></th>
                                    <th class="center mobileHide"><?php echo UCWords(t("percentage")); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                if(COUNT($dataForPie))
                                {
                                    foreach ($dataForPie AS $dataRow)
                                    {
                                        $countryCode = $dataRow['country'] ? $dataRow['country'] : "unknown";
                                        $flagPath    = SITE_IMAGE_PATH . "/stats/flags/" . strtolower($countryCode) . ".png";
                                        echo "<tr>";
                                        echo "<td><img src=\"" . $flagPath . "\" width='16' height='11' alt=\"" . t($countryCode, $countryCode) . "\">&nbsp;&nbsp;" . t($countryCode, $countryCode) . "</td>";
                                        echo "<td class=\"center\">" . $dataRow['total'] . "</td>";
                                        echo "<td class=\"center mobileHide\">" . number_format(($dataRow['total'] / $totalVisits) * 100, 1) . "%</td>";
                                        echo "</tr>";
                                    }
                                }
                                else
                                {
                                    echo '<tr><td colspan="3">'.t('no_data', 'No data').'</td></tr>';
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>

                </div>

                <div id="referChart" class="chart">
                    <div class="chartItem">
                    <?php
                    /* pie chart  */
                    $dataForPie  = $db->getRows("SELECT base_url, COUNT(id) AS total FROM stats WHERE page_title = '" . $shortUrlObj->id . "' GROUP BY base_url ORDER BY total DESC LIMIT 20");

                    $strXML = "";
                    $strXML .= "<graph animation='1' showValues='0' showNames='1' pieRadius='95' decimalPrecision='0' formatNumberScale='0' baseFont='Arial' baseFontSize='10'>";
                    foreach ($dataForPie AS $dataRow)
                    {
                        $position = rand(0, COUNT($colours) - 1);
                        $strXML .= "<set name='" . (($dataRow['base_url'])) . "' value='" . $dataRow['total'] . "' color='" . $colours[$position] . "'/>";
                    }
                    $strXML .= "</graph>";

                    echo renderChartHTML("js/fusionCharts/Charts/FCF_Pie2D.swf", "", $strXML, "statusPie", 830, 250);
                    ?>

                    <?php
                    /* total visits figure */
                    $totalVisits = 0;
                    foreach ($dataForPie AS $dataRow)
                    {
                        $totalVisits = $totalVisits + $dataRow['total'];
                    }
                    ?>
                    </div>

                    <br/>

                    <div>
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th><?php echo UCWords(t("site")); ?></th>
                                    <th class="center"><?php echo UCWords(t("total_visits")); ?></th>
                                    <th class="center mobileHide"><?php echo UCWords(t("percentage")); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                if(COUNT($dataForPie))
                                {
                                    foreach ($dataForPie AS $dataRow)
                                    {
                                        $baseUrl = $dataRow['base_url'] ? $dataRow['base_url'] : "direct";
                                        echo "<tr>";
                                        echo "<td>";
                                        if ($dataRow['base_url'])
                                        {
                                            echo "<a href='http://" . $baseUrl . "' target='_blank'>" . $baseUrl . "</a>";
                                        }
                                        else
                                        {
                                            echo $baseUrl;
                                        }
                                        echo "</td>";
                                        echo "<td class=\"center\">" . $dataRow['total'] . "</td>";
                                        echo "<td class=\"center mobileHide\">" . number_format(($dataRow['total'] / $totalVisits) * 100, 1) . "%</td>";
                                        echo "</tr>";
                                    }
                                }
                                else
                                {
                                    echo '<tr><td colspan="3">'.t('no_data', 'No data').'</td></tr>';
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>

                </div>

                <div id="browserChart" class="chart">
                    <div class="chartItem">
                    <?php
                    /* pie chart  */
                    $dataForPie = $db->getRows("SELECT browser_family, COUNT(id) AS total FROM stats WHERE page_title = '" . $shortUrlObj->id . "' GROUP BY browser_family ORDER BY total DESC LIMIT 20");

                    $strXML = "";
                    $strXML .= "<graph animation='1' showValues='0' showNames='1' pieRadius='95' decimalPrecision='0' formatNumberScale='0' baseFont='Arial' baseFontSize='10'>";
                    foreach ($dataForPie AS $dataRow)
                    {
                        $position = rand(0, COUNT($colours) - 1);
                        $strXML .= "<set name='" . UCWords($dataRow['browser_family']) . "' value='" . $dataRow['total'] . "' color='" . $colours[$position] . "'/>";
                    }
                    $strXML .= "</graph>";

                    echo renderChartHTML("js/fusionCharts/Charts/FCF_Pie2D.swf", "", $strXML, "statusPie", 830, 250);
                    ?>

                    <?php
                    /* total visits figure */
                    $totalVisits = 0;
                    foreach ($dataForPie AS $dataRow)
                    {
                        $totalVisits = $totalVisits + $dataRow['total'];
                    }
                    ?>
                    </div>

                    <br/>

                    <div>
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th><?php echo UCWords(t("browser")); ?></th>
                                    <th class="center"><?php echo UCWords(t("total_visits")); ?></th>
                                    <th class="center mobileHide"><?php echo UCWords(t("percentage")); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                if(COUNT($dataForPie))
                                {
                                    foreach ($dataForPie AS $dataRow)
                                    {
                                        $browser    = $dataRow['browser_family'] ? $dataRow['browser_family'] : "unknown";
                                        $iconPath   = SITE_IMAGE_PATH . "/stats/browsers/" . strtolower($browser) . ".png";
                                        echo "<tr>";
                                        echo "<td><img src=\"" . $iconPath . "\" width='14' height='14' alt=\"" . $browser . "\" style=\"float:left;\">&nbsp;&nbsp;" . UCWords($browser) . "</td>";
                                        echo "<td class=\"center\">" . $dataRow['total'] . "</td>";
                                        echo "<td class=\"center mobileHide\">" . number_format(($dataRow['total'] / $totalVisits) * 100, 1) . "%</td>";
                                        echo "</tr>";
                                    }
                                }
                                else
                                {
                                    echo '<tr><td colspan="3">'.t('no_data', 'No data').'</td></tr>';
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>

                </div>

                <div id="osChart" class="chart">
                    <div class="chartItem">
                    <?php
                    /* pie chart  */
                    $dataForPie = $db->getRows("SELECT os, COUNT(id) AS total FROM stats WHERE page_title = '" . $shortUrlObj->id . "' GROUP BY os ORDER BY total DESC LIMIT 20");

                    $strXML = "";
                    $strXML .= "<graph animation='1' showValues='0' showNames='1' pieRadius='95' decimalPrecision='0' formatNumberScale='0' baseFont='Arial' baseFontSize='10'>";
                    foreach ($dataForPie AS $dataRow)
                    {
                        $position = rand(0, COUNT($colours) - 1);
                        $strXML .= "<set name='" . UCWords($dataRow['os']) . "' value='" . $dataRow['total'] . "' color='" . $colours[$position] . "'/>";
                    }
                    $strXML .= "</graph>";

                    echo renderChartHTML("js/fusionCharts/Charts/FCF_Pie2D.swf", "", $strXML, "statusPie", 830, 250);
                    ?>

                    <?php
                    /* total visits figure */
                    $totalVisits = 0;
                    foreach ($dataForPie AS $dataRow)
                    {
                        $totalVisits = $totalVisits + $dataRow['total'];
                    }
                    ?>
                    </div>

                    <br/>

                    <div>
                        <table class="table table-bordered table-striped">
                            <thead>
                                <tr>
                                    <th><?php echo UCWords(t("operating_system")); ?></th>
                                    <th class="center"><?php echo UCWords(t("total_visits")); ?></th>
                                    <th class="center mobileHide"><?php echo UCWords(t("percentage")); ?></th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                if(COUNT($dataForPie))
                                {
                                    foreach ($dataForPie AS $dataRow)
                                    {
                                        $os       = $dataRow['os'] ? $dataRow['os'] : "unknown";
                                        $iconPath = SITE_IMAGE_PATH . "/stats/os/" . strtolower($os) . ".png";
                                        echo "<tr>";
                                        echo "<td><img src=\"" . $iconPath . "\" width='14' height='14' alt=\"" . $os . "\" style=\"float:left;\">&nbsp;&nbsp;" . UCWords($os) . "</td>";
                                        echo "<td class=\"center\">" . $dataRow['total'] . "</td>";
                                        echo "<td class=\"center mobileHide\">" . number_format(($dataRow['total'] / $totalVisits) * 100, 1) . "%</td>";
                                        echo "</tr>";
                                    }
                                }
                                else
                                {
                                    echo '<tr><td colspan="3">'.t('no_data', 'No data').'</td></tr>';
                                }
                                ?>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>
        <hr>
    </div>
</div>

<?php
require_once('_footer.php');
?>